import matplotlib.pyplot as plt
import numpy as np


def Newton4(x0,f,df,eps):
    # Version 4 1d
    itmax=20
    it=0
    x=x0
    crit=np.abs(f(x0))
    liste_x=np.zeros(itmax+1)
    liste_crit=np.zeros(itmax+1)
    liste_x[0]=x0
    liste_crit[0]=np.abs(f(x0))
    while crit > eps and it < itmax:
        it+=1
        x=x-f(x)/df(x)
        crit=np.abs(f(x))
        liste_x[it]=x
        liste_crit[it]=crit
    return liste_x,liste_crit,it


def f1(x):
    return np.exp(x)-np.e

def df1(x):
    return np.exp(x)


x0=5
f=f1
df=df1
eps=1e-6

tabx,tabcrit,it=Newton4(x0,f,df,eps)
print('La méthode converge en ',it,'pas')

# Graphe des itérés

tabxeff=tabx[:it]
tabyeff=f1(tabxeff)
tabcriteff=tabcrit[:it]


t=np.linspace(-6,5,200)
yt=f1(t)
#plt.plot(t,yt,tabxeff,tabcriteff,tabxeff[-1],tabcriteff[-1],'*')
plt.plot(t,yt,tabxeff,tabyeff,tabxeff[-1],tabyeff[-1],'*')
plt.title('Itérés pour f1 et x0=5')
plt.show()

err=tabxeff-tabxeff[-1]
errx=err[1:-1]
erry=err[2:]
plt.plot(errx,erry,errx[-1],erry[-1],'*')
plt.title('Croissance quadratique des erreurs')
plt.show()

errx2=errx
lx=len(errx)
for i in range(lx):
    errx2[i]=errx[i]**2
    
plt.plot(errx2,erry,errx2[0],erry[0],'o',errx2[-1],erry[-1],'*')
plt.title('Comparaison avec le carré  des erreurs: on cherche une droite')
plt.show()
    
lerrx=np.log(errx[:-1])
lerry=np.log(erry[:-1])

plt.plot(lerrx,lerry,lerrx[0],lerry[0],'o',lerrx[-1],lerry[-1],'*')
plt.title('Log erreur pour f1 et x0=5')
plt.show()
    
A=np.polyfit(lerrx,lerry,1)
print('Pente de log erreur pour f1 et x0=5:',A[0])