import matplotlib.pyplot as plt
import numpy as np


def Newton6(x0,f,df,eps):
    # Version 6 vectorielle
    itmax=20
    it=0
    x=x0
    crit=np.linalg.norm(f(x0))
    liste_it=np.zeros(itmax+1)
    liste_crit=np.zeros(itmax+1)
    liste_x=np.zeros(itmax+1)
    liste_y=np.zeros(itmax+1)
    liste_it[0]=0
    liste_crit[0]=crit
    liste_x[0]=x[0]
    liste_y[0]=x[1]
    while crit > eps and it < itmax:
        it+=1
        x=x-np.linalg.solve(df(x),f(x))
        crit=np.linalg.norm(f(x))
        liste_it[it]=it
        liste_crit[it]=crit
        liste_x[it]=x[0]
        liste_y[it]=x[1]
    return liste_x,liste_y,liste_crit,liste_it,it



def f2(x):
    x1=x[0]
    x2=x[1]
    x1=x1**2
    x2=x2**2
    y1=x1+x2-2
    y2=x1-x2-1
    return y1,y2

def df2(x):
    x1=x[0]
    x2=x[1]
    y11=2*x1
    y12=2*x2
    y21=y11
    y22=-y12
    y1=[y11,y12]
    y2=[y21,y22]
    return y1,y2


t=np.linspace(0,2*np.pi,100)
r=np.sqrt(2)
xt=r*np.cos(t)
yt=r*np.sin(t)
#plt.plot(xt,yt)

s=np.linspace(-2,2,600)
xs=np.cosh(s)
ys=np.sinh(s)


x0=np.array([2,2])
f=f2
df=df2
eps=1e-6

tabit=np.zeros(10)
i=0
tabp=np.arange(1,11)
for p in range(1,11):
    x0=np.array([2**(-p),1])
    liste_x,liste_y,liste_crit,liste_it,it=Newton6(x0,f,df,eps)
    tabit[i]=it
    i+=1
    
plt.plot(tabp,tabit)
plt.title('Nombre des itérés en fonction de p')
plt.show()
    
A=np.polyfit(tabp,tabit,1)
print('Pente=',A[0])


x0=np.array([2**(-10),1])
f=f2
df=df2
eps=1e-6

liste_x,liste_y,liste_crit,liste_it,it=Newton6(x0,f,df,eps)
tabxeff=liste_x[:it]
tabyeff=liste_y[:it]

plt.plot(xt,yt,xs,ys,-xs,ys,tabxeff,tabyeff)
plt.title('Itérés pour x0 fontion de p')
plt.show()

err=np.zeros(it)
for i in range(it):
    err[i]=np.linalg.norm(np.array([tabxeff[i]-tabxeff[-1],tabyeff[i]-tabyeff[-1]]))
errx=err[1:-1]
erry=err[2:]
plt.plot(errx,erry,errx[-1],erry[-1],'*')
plt.title('Evolution de l Erreur')
plt.show()

lerrx=np.log(errx[:-1])
lerry=np.log(erry[:-1])

plt.plot(lerrx,lerry,lerrx[-1],lerry[-1],'*')
plt.title('Log-Erreur ')
plt.show()

lx=len(lerrx)
lerr=np.zeros(lx)
tabi=np.arange(lx)
for i in range(lx):
    lerr[i]=lerry[i]/lerrx[i]
    
plt.plot(tabi,lerr,tabi[-1],lerr[-1],'*')  
plt.title('Evolution de la pente de log-erreur ')
plt.show()

A=np.polyfit(lerrx,lerry,1)
print('Pente de log erreur pour f2 et x0=[-3,5]:',A[0])
