#Dans Terminal
#jupyter lab
#python tp2.py
#

import matplotlib.pyplot as plt
import numpy as np


def Newton_mod(x0,f,df,eps,p):
    # Version 1d
    itmax=20
    it=0
    x=x0
    crit=np.abs(f(x0))
    liste_x=np.zeros(itmax+1)
    liste_crit=np.zeros(itmax+1)
    liste_x[0]=x0
    liste_crit[0]=np.abs(f(x0))
    while crit > eps and it < itmax:
        it+=1
        x=x-p*f(x)/df(x)
        crit=np.abs(f(x))
        liste_x[it]=x
        liste_crit[it]=crit
    return liste_x,liste_crit,it




def f2(x):
    return (np.exp(x)-np.e)**2

def df2(x):
    return 2*(np.exp(x)-np.e)*np.exp(x)

def f3(x):
    return (np.exp(x)-np.e)**(5/2)

def df3(x):
    return 5*((np.exp(x)-np.e)**(3/2))*np.exp(x)/2



t=np.linspace(-6,5,200)
yt=f2(t)
dyt=df2(t)

plt.subplot(1,2,1)
plt.plot(t,yt)
plt.title('Graphe de f2')

plt.subplot(1,2,2)
plt.plot(t,dyt)
plt.title('Graphe de la dérivée de f2')
plt.show()


#t=np.linspace(-6,5,200)
zt=f3(t)
dzt=df3(t)

plt.subplot(1,2,1)
plt.plot(t,zt)
plt.title('Graphe de f3')

plt.subplot(1,2,2)
plt.plot(t,dzt)
plt.title('Graphe de la dérivée de f3')
plt.show()


x0=5
eps=1e-6
f=f2
df=df2
p=2


liste_x,liste_crit,it=Newton_mod(x0,f,df,eps,p)
print('La methode pour f2 converge en',it,'pas')
tabxeff=liste_x[:it]
tabyeff=liste_crit[:it]
plt.plot(t,yt,tabxeff,tabyeff,tabxeff[-1],tabyeff[-1],'*')
plt.title('Iteres pour f2')
plt.show()



err=tabxeff-tabxeff[-1]
errx=err[1:-1]
erry=err[2:]
plt.plot(errx,erry,errx[0],erry[0],'o',errx[-1],erry[-1],'*')
plt.title('Croissance quadratique de lErreur pour f2 et x0=5')
plt.show()
   
    
errx2=errx
lx=len(errx)
for i in range(lx):
    errx2[i]=errx[i]**2
    
plt.plot(errx2,erry,errx2[0],erry[0],'o',errx2[-1],erry[-1],'*')
plt.title('Comparaison avec le carré de l Erreur: recherche d une droite')
plt.show()


lerrx=np.log(errx[:-1])
lerry=np.log(erry[:-1])
print(lerrx)
print(lerry)

plt.plot(lerrx,lerry,lerrx[-1],lerry[-1],'*')
plt.title('Log Erreur pour f2 et x0=5')
plt.show()

A=np.polyfit(lerrx,lerry,1)
print('Pente  de log erreur pour f2 et x0=5')


###### On recommence pour x0=-5 #######
x0=-5
eps=1e-6
f=f2
df=df2
p=2


liste_x,liste_crit,it=Newton_mod(x0,f,df,eps,p)
print('La methode pour f2 converge en',it,'pas')
tabxeff=liste_x[:it]
tabyeff=liste_crit[:it]
plt.plot(t,yt,tabxeff,tabyeff,tabxeff[-1],tabyeff[-1],'*')
plt.title('Iteres pour f2 et x0=-5')
plt.show()


##### On recommence pour f3 et x0=5 #######
x0=5
eps=1e-6
f=f3
df=df3
p=2.5


liste_x,liste_crit,it=Newton_mod(x0,f,df,eps,p)
print('La methode pour f3 converge en',it,'pas')
tabxeff=liste_x[:it]
tabyeff=liste_crit[:it]
plt.plot(t,zt,tabxeff,tabyeff,tabxeff[-1],tabyeff[-1],'*')
plt.title('Iteres pour f3 et x0=5')
plt.show()

err=tabxeff-tabxeff[-1]
errx=err[1:-1]
erry=err[2:]
plt.plot(errx,erry,errx[0],erry[0],'o',errx[-1],erry[-1],'*')
plt.title('Croissance quadratique de lErreur pour f3 et x0=5')
plt.show()


errx2=errx
lx=len(errx)
for i in range(lx):
    errx2[i]=errx[i]**2
    
plt.plot(errx2,erry,errx2[0],erry[0],'o',errx2[-1],erry[-1],'*')
plt.title('Comparaison avec le carré de l Erreur pour f3: recherche d une droite')
plt.show()

lerrx=np.log(errx[:-1])
lerry=np.log(erry[:-1])
print(lerrx)
print(lerry)

plt.plot(lerrx,lerry,lerrx[0],lerry[0],'o',lerrx[-1],lerry[-1],'*')
plt.title('Log Erreur pour f3 et x0=5')
plt.show()

A=np.polyfit(lerrx,lerry,1)
print('Pente  de log erreur pour f3 et x0=5:',A[0])
